/**
 * \file gre/uidlgdefineregion.h
 * \brief GRE::UI::DLG_DEFINEREGION definitions
 *
 * \if NODOC
 * $Id: uidlgdefineregion.h_v 1.1 2014/03/10 17:43:47 mju Exp $
 *
 * $Log: uidlgdefineregion.h_v $
 * Revision 1.1  2014/03/10 17:43:47  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_GRE_UIDLGDDEFINEREGION_H
#define	INC_GRE_UIDLGDDEFINEREGION_H

#ifndef	INC_MGUI_DLGSHELL_H
#include <mgui/dlgshell.h>
#endif

#ifndef	INC_RVC_OBJITEM_H
#include <rvc/objitem.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
// Forward declarations
class REGION2D;
namespace GRE {
	class GROUP;
	class MSG;
	namespace UI {
		class FORM_VIEW;
		class VIEWTOOL_DEFINEREGION;
		class VIEW_CANVAS;
		}
	}
#endif

namespace GRE {
namespace UI {

//===================================================================================================================

//! Dialog to define region.
class DLG_DEFINEREGION : public MGUI::DLGSHELL {
	public:

		//! Constructor.
		explicit DLG_DEFINEREGION (
			const MISTRING& title,				//!< Title for dialog
			const RVC::OBJITEM& ObjItemRef	//!< Reference object to display
			);

		//! Destructor.
		virtual ~DLG_DEFINEREGION ();

		//! Get currently defined region.
		const REGION2D& GetRegion () const;

		//! Set delegate to call when Apply pressed on modeless dialog.
		void SetDelegateOnApply (
			DELEGATE_VOID_NOPARMS delegate
			) { m_delegateOnApply = delegate; }

		//! Set region.
		void SetRegion (
			const REGION2D& region		//!< Region to set
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		typedef DLG_DEFINEREGION THISCLASS;

		RVC::OBJITEM m_ObjItemRef;
		GROUP *m_Group;
		FORM_VIEW *m_pFormView;
		VIEWTOOL_DEFINEREGION *m_pViewTool;
		REGION2D *m_pInitRegion;
		DELEGATE_VOID_NOPARMS m_delegateOnApply;

		static void GRECB_Group (const GRE::MSG *pMsg, void *vpDlg);

		void OnGreMsgGroup (const GRE::MSG& msg);
		void OnViewAddTools (GRE::UI::VIEW_CANVAS *view);

		virtual ERRVALUE v_CreateContent ();
		virtual void v_OnApply ();
		#endif
	};

//===================================================================================================================

}	// End namespace UI
}	// End namespace GRE

#endif	// INC_GRE_UIDLGDDEFINEREGION_H
