/**
 * \file gre/uiformdispparm.h
 * \brief GRE::UI::FORM_DISPPARM definitions
 *
 * \if NODOC
 * $Id: uiformdispparm.h_v 1.1 2013/04/05 16:55:38 mju Exp $
 *
 * $Log: uiformdispparm.h_v $
 * Revision 1.1  2013/04/05 16:55:38  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_GRE_UI_FORMDISPPARM_H
#define	INC_GRE_UI_FORMDISPPARM_H

#ifndef	INC_MGUI_EDIT_H
#include <mgui/edit.h>
#endif

#ifndef	INC_GRE_LAYER_H
#include <gre/layer.h>
#endif


namespace GRE {
namespace UI {

//=====================================================================================================================

//! Form for controlling visible scale range in LAYER::DISPPARM.
class FORM_DISPPARM_SCALERANGE : protected MGUI::FORM_EDIT_RANGE {
	public:

		//! Constructor.
		FORM_DISPPARM_SCALERANGE ();

		//! Destructor.
		virtual ~FORM_DISPPARM_SCALERANGE ();

		//! Create form with default label.
		void Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane,
			const LAYER::DISPPARM& dispparm
			);

		//! Get values.
		//! If form has not been create values will be left unchanged.
		void GetValues (
			LAYER::DISPPARM& dispparm				//!< Where to place result
			);

		//! Set delegate to call when value changed.
		void SetDelegateOnChangeValue (
			DELEGATE_VOID_NOPARMS delegate
			) { BASECLASS::SetDelegateOnChangeValue(delegate); }

		//! Set values from DISPPARM.
		void SetValues (
			const LAYER::DISPPARM& dispparm,		//!< Values to set
			bool notify = true						//!< Whether to notify via delegate on change
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		typedef FORM_EDIT_RANGE BASECLASS;
		#endif
	};

//=====================================================================================================================

}	// End namespace UI
}	// End namespace GRE

#endif	// INC_GRE_UI_FORMDISPPARM_H
