/**
 * \file gre/uimapgrd.h
 * \brief GRE User Interface definitions for MapGrid layer.
 *
 * \if NODOC
 * $Id: uimapgrd.h_v 1.7 2013/04/11 22:28:11 mju Exp $
 *
 * $Log: uimapgrd.h_v $
 * Revision 1.7  2013/04/11 22:28:11  mju
 * Update to mgui.
 *
 * Revision 1.1  2002/09/10 14:25:01  mju
 * Initial revision
 * \endif
**/

#ifndef	INC_GRE_UIMAPGRD_H
#define	INC_GRE_UIMAPGRD_H

#ifndef	INC_GRE_LRMAPGRD_H
#include <gre/lrmapgrd.h>
#endif

#ifndef	INC_MGUI_DLGSHELL_H
#include <mgui/dlgshell.h>
#endif

namespace GRE {

//=====================================================================================================================

//! Dialog for modifying map grid layer display settings.
class LAYER_MAPGRID::DISPPARM::DLG : public MGUI::DLGSHELL {
	public:

		//! Constructor.
		explicit DLG (
			LAYER_MAPGRID *layer,
			bool Include3D						//!< Include 3D settings
			);

		//! Destructor.
		virtual ~DLG ();

		const LAYER_MAPGRID::DISPPARM& GetValues () const;

		void SetValues (
			const LAYER_MAPGRID::DISPPARM& values
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;

		virtual ERRVALUE v_CreateContent ();
		virtual void v_OnApply ();
		virtual void v_OnClose ();
		virtual void v_OnOK ();
		virtual void v_OnOpen ();

		#endif // GENERATING_DOXYGEN_OUTPUT
	};

//=====================================================================================================================

}	// End namespace GRE

#endif	// INC_GRE_UIMAPGRD_H
