/**
 * \file gre/uiviewtoollocator.h
 * \brief GRE::UI::VIEWTOOL_LOCATOR
 *
 * \if NODOC
 * $Id: uiviewtoollocator.h_v 1.1 2015/07/23 21:44:31 mju Exp $
 *
 * $Log: uiviewtoollocator.h_v $
 * Revision 1.1  2015/07/23 21:44:31  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_GRE_UIVIEWTOOLLOCATOR_H
#define	INC_GRE_UIVIEWTOOLLOCATOR_H

#ifndef	INC_GRE_UIVIEWTOOL_H
#include <gre/uiviewtool.h>
#endif

#ifndef	INC_MGUI_TOOLRECTANGLE_H
#include <mgui/toolrectangle.h>
#endif

namespace GRE {
namespace UI {

//===================================================================================================================

class VIEWTOOL_LOCATOR : public GRE::UI::VIEWTOOL {
	public:

		VIEWTOOL_LOCATOR (
			GRE::UI::VIEW_CANVAS *viewlocator,
			GRE::UI::VIEW_CANVAS *viewmain
			);
		virtual ~VIEWTOOL_LOCATOR ();

	private:
		typedef VIEWTOOL_LOCATOR THISCLASS;

		GRE::UI::VIEW_CANVAS *m_viewmain;
		MGUI::TOOL_RECTANGLE m_ToolRectangle;

		static void GRECB_View (const GRE::MSG *pMsg, void *vpViewTool);

		void OnChange (MGUI::TOOL_BASE::CHANGESEQ ChgSeq, MGUI::TOOL_BASE::CHANGETYPE ChgType);
		void SetupTrans ();
		void UpdatePosition (bool IsFromDraw);

		virtual bool v_Activate ();
		virtual void v_Deactivate ();
		virtual bool v_Initialize ();
		virtual void v_Suspend ();
		virtual void v_Resume ();
	};

//===================================================================================================================

}	// End namespace UI
}	// End namespace GRE

#endif	// INC_GRE_UIVIEWTOOLLOCATOR_H
