/** 
 * \file mgui/dlgschedulejob.h 
 * \brief Definitions for MGUI::DLG_SCHEDULE_JOB class.
 *
 * \if NODOC
 * $Id: dlgschedulejob.h_v 1.5 2014/03/10 19:26:17 bcolombe Exp $
 *
 * $Log: dlgschedulejob.h_v $
 * Revision 1.5  2014/03/10 19:26:17  bcolombe
 * Some GUI changes, add once option
 *
 * Revision 1.4  2011/11/22 13:27:52  mju
 * Remove redundant hdrs.
 *
 * Revision 1.3  2011/08/26 13:28:50  mju
 * Use formradiobuttons hdr.
 *
 * Revision 1.2  2009/07/06 20:38:14  bcolombe
 * Added changes for advanced schedule options
 *
 * Revision 1.1  2009/06/22 14:55:25  bcolombe
 * Initial revision
 * \endif
**/

#ifndef	INC_MGUI_DLG_SCHEDULE_JOB_H
#define	INC_MGUI_DLG_SCHEDULE_JOB_H

#ifndef INC_MGUI_DLGSHELL_H
#include <mgui/dlgshell.h>
#endif

#ifndef INC_MI32_FILEPATH_H
#include <mi32/filepath.h>
#endif

class MIJOB;
namespace MGUI {

class DLG_SCHEDULE_JOB : public MGUI::DLGSHELL {
	public:
		//! Use defaults
		DLG_SCHEDULE_JOB ();

		//! Initialize from existing job.  Will write to on OK
		DLG_SCHEDULE_JOB (
			const FILEPATH& path		//!< Path of job
			);

		//! Destructor
		virtual ~DLG_SCHEDULE_JOB ();

		//! Display schedule dlg and write new job
		ERRVALUE CreateJob (
			MIJOB& job,						//!< Normal job that will be given schedule parms and written
			MDLGPARENT DlgParent = 0		//!< DlgParent for dialog
			);
 
		//! Output dlg to existing job
		ERRVALUE WriteToJob (
			const FILEPATH& path			//!< Path of job to write
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;
		FILEPATH m_path;
		virtual ERRVALUE v_CreateContent();
		virtual void v_OnOK();
		#endif // GENERATING_DOXYGEN_OUTPUT
	};

}	// End of MGUI namespace

#endif		//	INC_MGUI_FORM_COORD_H
