/**
 * \file mgui/formbinglocation.h
 *
 * \if NODOC
 * $Id: formbinglocation.h_v 1.6 2013/11/11 17:52:26 bcolombe Exp $
 *
 * $Log: formbinglocation.h_v $
 * Revision 1.6  2013/11/11 17:52:26  bcolombe
 * Destructor should be virtual
 *
 * Revision 1.5  2013/08/09 21:50:23  bcolombe
 * HasItemSelected and OnChangeSelection
 *
 * Revision 1.4  2013/08/02 17:20:55  bcolombe
 * Add flags for not making details list
 *
 * Revision 1.3  2013/07/26 20:13:31  bcolombe
 * Add save delegate
 *
 * Revision 1.2  2013/07/25 22:21:13  bcolombe
 * AddToolBarButtons method
 *
 * Revision 1.1  2013/07/18 22:41:59  bcolombe
 * Initial revision
 *
 * \endif
****************************************************************************/

#ifndef	INC_MGUI_FORMBINGLOCATION_H
#define	INC_MGUI_FORMBINGLOCATION_H

#ifndef INC_MGUI_FORMLIST_H
#include <mgui/form.h>
#endif

#ifndef INC_MGUI_TOOLBAR_H
#include <mgui/toolbar.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
// Forward declarations.
namespace GRE {
	class VIEW;
	}
#endif

namespace MGUI {

//! Form for finding location with bing service
class FORM_BINGLOCATION : public MGUI::FORM_COMPOSITE {
	public:
		enum FLAGS {
			FLAG_Default =		0x0000,
			FLAG_NoDetails =	0x0001
			};

		FORM_BINGLOCATION (
			);

		virtual ~FORM_BINGLOCATION (
			);

		//! Add toolbar buttons
		void AddToolBarButtons (
			MGUI::CTRL_TOOLBAR& ToolBar
			);

		//! Create Form
		void Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane,
			MGUI::LAYOUT_PANE_BASE& SearchPane,
			GRE::VIEW* view = 0,
			FLAGS flags = FLAG_Default
			);

		//! Get extents of selected item
		void GetSelectedExtents (DRECT2D& Extents);

		bool HasItemSelected() const;

		//! Delegate on change selection
		void SetDelegateOnChangeSelection (
			DELEGATE_VOID_INT32 delegate
			);

		//! Delegate to saved location
		void SetSaveDelegate (
			FastDelegate<void(const MISTRING&, const DRECT2D&)> delegate
			);

		//! Delegate to zoom to extents
		void SetZoomDelegate (
			FastDelegate<void(const DRECT2D&)> delegate
			);

	private:	
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;
		#endif
	};

} //end MGUI namespace

#endif //INC_MGUI_FORMBINGLOCATION_H
