/**
 * \file mgui/formfoldertree.h
 *
 * \if NODOC
 * $Id: formfoldertree.h_v 1.1 2015/09/09 23:04:01 bcolombe Exp $
 *
 * $Log: formfoldertree.h_v $
 * Revision 1.1  2015/09/09 23:04:01  bcolombe
 * Initial revision
 *
 *
 * \endif
****************************************************************************/

#ifndef	INC_MGUI_FORMFOLDERTREE_H
#define	INC_MGUI_FORMFOLDERTREE_H

#ifndef INC_MGUI_FORMLIST_H
#include <mgui/form.h>
#endif

#ifndef INC_MGUI_TREE_H
#include <mgui/tree.h>
#endif

#ifndef INC_MI32_FILEPATH_H
#include <mi32/filepath.h>
#endif

namespace MGUI {

//! Form for using saved view locations
class FORM_FOLDERTREE : public MGUI::FORM_COMPOSITE {
	public:
		typedef fastdelegate::FastDelegate<void(const FILEPATH&)> DELEGATE_ONCHANGESELECTION;

		FORM_FOLDERTREE (
			);

		virtual ~FORM_FOLDERTREE (
			);

		//! Create Form
		void Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane,
			int height = 20,	//!< in pixels
			int width = 40		//!< in pixels
			);

		bool HasItemSelected() const;

		//! Delegate on change selection
		void SetDelegateOnChangeSelection (
			DELEGATE_ONCHANGESELECTION delegate
			);
		
		//! Set current path
		void SetPath (
			const FILEPATH& filepath,
			bool bHighlight = true		//!< If true, will highlight in black, if false in gray
			);

	private:	
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;
		#endif
	};

} //end MGUI namespace

#endif //INC_MGUI_FORMFOLDERTREE_H
