/**
 * \file mgui/formgooglekeys.h
 * \brief MGUI::FORM_GOOGLEKEYS class definitions
 *
 * \if NODOC
 * $Id$
 *
 * $Log$
 * \endif
**/

#ifndef	INC_MGUI_FORMGOOGLEKEYS_H
#define	INC_MGUI_FORMGOOGLEKEYS_H

#ifndef	INC_MGUI_FORM_H
#include <mgui/form.h>
#endif

class MISTRING;
class MISTRINGLIST;

namespace MGUI {

class CTRL_LABEL;

//===================================================================================================================
//! Form for choosing Google API Key(s).
class FORM_GOOGLEKEYS : public MGUI::FORM_COMPOSITE {
	public:

		//! Constructor.
		FORM_GOOGLEKEYS ();

		~FORM_GOOGLEKEYS ();

		//! Create form with default label.
		void Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane	//!< Parent pane
			);

		//! Create form with specified label.
		void Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane,	//!< Parent pane
			const MISTRING& label					//!< Button label string
			);

		//! Get list of keys selected, if any.
		//! Will return empty list if no key selected.
		const MISTRINGLIST& GetKeyList (
			) const;

		//! Get label for alignment.
		CTRL_LABEL& GetLabel (
			);

		//! Set delegate to call when key selection changed.
		void SetDelegateOnChangeSelection (
			DELEGATE_VOID_NOPARMS delegate
			);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;

		FORM_GOOGLEKEYS (const FORM_GOOGLEKEYS&);
		FORM_GOOGLEKEYS& operator= (const FORM_GOOGLEKEYS&);
		#endif // GENERATING_DOXYGEN_OUTPUT
	};


//===================================================================================================================

}	// End namespace MGUI

#endif	// INC_MGUI_FORMGOOGLEKEYS_H
