/**
 * \file mgui/formsavedlocations.h
 *
 * \if NODOC
 * $Id: formsavedlocations.h_v 1.4 2013/11/11 17:52:11 bcolombe Exp $
 *
 * $Log: formsavedlocations.h_v $
 * Revision 1.4  2013/11/11 17:52:11  bcolombe
 * Destructor should be virtual
 *
 * Revision 1.3  2013/08/09 21:49:47  bcolombe
 * HasItemSelected and OnChangeSelection
 *
 * Revision 1.2  2013/07/26 20:13:47  bcolombe
 * Add SaveItem
 *
 * Revision 1.1  2013/07/25 22:22:02  bcolombe
 * Initial revision
 *
 * Revision 1.1  2013/07/18 22:41:59  bcolombe
 * Initial revision
 *
 * \endif
****************************************************************************/

#ifndef	INC_MGUI_FORMSAVEDLOCATIONS_H
#define	INC_MGUI_FORMSAVEDLOCATIONS_H

#ifndef INC_MGUI_FORMLIST_H
#include <mgui/form.h>
#endif

#ifndef INC_MGUI_TOOLBAR_H
#include <mgui/toolbar.h>
#endif

#ifndef INC_MGUI_TREE_H
#include <mgui/tree.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
// Forward declarations.
namespace GRE {
	class VIEW;
	}
#endif

namespace MGUI {

//! Form for using saved view locations
class FORM_SAVEDLOCATIONS : public MGUI::FORM_COMPOSITE {
	public:
		FORM_SAVEDLOCATIONS (
			);

		virtual ~FORM_SAVEDLOCATIONS (
			);

		//! Add toolbar buttons
		void AddToolBarButtons (
			MGUI::CTRL_TOOLBAR& ToolBar
			);

		//! Create Form
		void Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane,
			GRE::VIEW* view = 0
			);

		//! Get extents of selected item
		void GetSelectedExtents (DRECT2D& Extents);

		bool HasItemSelected() const;

		//! Specify item to save
		void SaveItem (
			const MISTRING& Name,
			const DRECT2D& Extents
			);

		//! Delegate on change selection
		void SetDelegateOnChangeSelection (
			MGUI::CTRL_TREE::DELEGATE_ONITEM delegate
			);

		//! Delegate to zoom to extents
		void SetZoomDelegate (
			FastDelegate<void(const DRECT2D&)> delegate
			);

		//! Update contents of view tree
		void UpdateTree ();

	private:	
		#ifndef GENERATING_DOXYGEN_OUTPUT
		class PRIV;
		PRIV *m_pPriv;
		#endif
	};

} //end MGUI namespace

#endif //INC_MGUI_FORMSAVEDLOCATIONS_H
