/**
 * \file mgui/formselectmoderegion.h
 * \brief MGUI::FORM_SELECTMODE_REGION definitions
 *
 * \if NODOC
 * $Id$
 *
 * $Log$
 * \endif
**/

#ifndef	INC_MGUI_FORMSELECTMODEREGION_H
#define	INC_MGUI_FORMSELECTMODEREGION_H

#ifndef	INC_MGUI_COMBOBOX_H
#include <mgui/combobox.h>
#endif

#ifndef	INC_RVC_GEOMETRC_H
#include <rvc/geometrc.h>
#endif

namespace MGUI {

//=====================================================================================================================
	
class FORM_SELECTMODE_REGION : public MGUI::FORM_COMPOSITE {
	public:
	
		//! Constructor.
		FORM_SELECTMODE_REGION ();

		//! Destructor.
		virtual ~FORM_SELECTMODE_REGION ();
	
		ERRVALUE Create (
			MGUI::LAYOUT_PANE_BASE& ParentPane,				//!< Parent pane
			RVC::OBJTYPE DestObjType,
			bool AddApplyToAllBtn = false,
			MGUI::LAYOUT_SIZEALIGN sizealign = MGUI::LAYOUT_SIZEALIGN_FixedSize
			);
			
		RVC::GEOMETRIC::ELEMSELECTPARMS::EXTRACT GetExtractMode () const;
			
		CTRL_LABEL& GetLabel ()
			{ return (m_CbxExtractMode.GetLabel()); }
			
		const REGION2D& GetRegion () const
			{ return (m_Region); }
			
		bool IsAddBorderEnabled () const;
			
		void SetAddBorder (
			bool value
			);

		void SetDelegateOnApplyToAll (
			DELEGATE_VOID_NOPARMS delegate
			) { m_DelegateOnApplyToAll = delegate; }
			
		void SetExtractMode (
			RVC::GEOMETRIC::ELEMSELECTPARMS::EXTRACT ExtractMode
			);
			
		void SetGeometricObject (
			const RVC::OBJITEM& ObjItem
			);
	
		void SetRegion (
			const REGION2D& region
			);
			
	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		typedef FORM_SELECTMODE_REGION THISCLASS;

		DELEGATE_VOID_NOPARMS m_DelegateOnApplyToAll;
		MGUI::FORM_COMBOBOX m_CbxExtractMode;
		MGUI::CTRL_PUSHBUTTON m_BtnSelect;
		MGUI::CTRL_PUSHBUTTON m_BtnApplyToAll;
		MGUI::CTRL_TOGGLEBUTTON m_TglAddBorder;
		RVC::OBJITEM m_ObjItem;
		REGION2D m_Region;
		RVC::OBJTYPE m_DestObjType;

		void OnBtnApplyToAll ();
		void OnBtnSelect ();
		void OnCbxExtractMode ();
		#endif // GENERATING_DOXYGEN_OUTPUT
	};

//=====================================================================================================================

}	// End namespace MGUI

#endif	// INC_MGUI_FORMSELECTMODEREGION_H
