/**
 * \file mi32/colorpalettetype.h
 * \brief COLORPALETTETYPE enumeration
 *
 * \if NODOC
 * $Id: colorpalettetype.h_v 1.1 2015/06/11 19:13:39 mju Exp $
 *
 * $Log: colorpalettetype.h_v $
 * Revision 1.1  2015/06/11 19:13:39  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_COLORPALETTETYPE_H
#define	INC_MI32_COLORPALETTETYPE_H

#ifndef	INC_MI32_STDDEFNS_H
#include <mi32/stddefns.h>
#endif

//! Color Palette type enumeration.
enum COLORPALETTETYPE {
	COLORPALETTETYPE_None =						0,
	COLORPALETTETYPE_Continuous =				0x01,		//!< "Continuous" palette usable for spread, stored as RVC object
	COLORPALETTETYPE_Discrete =				0x02,		//!< Palette of specific "discrete" colors, stored as XML file
	COLORPALETTETYPE_System =					0x10,		//!< Distributed with system
	COLORPALETTETYPE_User =						0x20,		//!< Added by user
	COLORPALETTETYPE_Continuous_System =	COLORPALETTETYPE_Continuous | COLORPALETTETYPE_System,
	COLORPALETTETYPE_Continuous_User =		COLORPALETTETYPE_Continuous | COLORPALETTETYPE_User,
	COLORPALETTETYPE_MASK_Style =				0x03,
	COLORPALETTETYPE_MASK_Source =			0x30,
	};
#ifndef GENERATING_DOXYGEN_OUTPUT
DEFINE_ENUM_OP_BITWISE(COLORPALETTETYPE)
#endif

#endif	// INC_MI32_COLORPALETTETYPE_H
