/**
 * \file <mi32/lidarenums.h>
 * \brief LIDAR enumeration definitions.
 *
 * \if NODOC
 * $Id: lidarenums.h_v 1.2 2014/10/30 17:48:15 mju Exp $
 *
 * $Log: lidarenums.h_v $
 * Revision 1.2  2014/10/30 17:48:15  mju
 * Add pointfield enum.
 *
 * Revision 1.1  2011/06/24 21:10:13  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_MI32_LIDARENUMS_H
#define	INC_MI32_LIDARENUMS_H

namespace LIDAR {

//=====================================================================================================================

//! Point "field" enumeration.
enum POINTFIELD {
	POINTFIELD_Invalid = 0,
	POINTFIELD_X,
	POINTFIELD_Y,
	POINTFIELD_Z,
	POINTFIELD_Intensity,
	POINTFIELD_ReturnNumber,
	POINTFIELD_ReturnCount,
	POINTFIELD_Class,
	POINTFIELD_ScanAngle,
	POINTFIELD_ScanDirection,
	POINTFIELD_Flag_Synthetic,
	POINTFIELD_Flag_KeyPoint,
	POINTFIELD_Flag_Deleted,
	POINTFIELD_Flag_Overlap,
	POINTFIELD_Flag_ScanEdge,
	POINTFIELD_User,
	POINTFIELD_SourceID,
	POINTFIELD_Time,
	POINTFIELD_Color_Red,
	POINTFIELD_Color_Green,
	POINTFIELD_Color_Blue,
	POINTFIELD_Color_NIR,
	};

//=====================================================================================================================

//! Point "return type" enumeration.
enum POINTRETURNTYPE {
	POINTRETURNTYPE_Single =				0,		//!< Single return
	POINTRETURNTYPE_FirstOfMultiple =	1,		//!< First of multiple returns
	POINTRETURNTYPE_LastOfMultiple =		2,		//!< Last of multiple returns
	POINTRETURNTYPE_Intermediate =		3,		//!< Intermediate return
	POINTRETURNTYPE_Invalid =				4,		//!< Invalid return
	POINTRETURNTYPE_None =					5,		//!< No return value present
	POINTRETURNTYPE_NUMTYPES =				6		//!< Number of types defined
	};

//=====================================================================================================================

}	// End namespace LIDAR

#endif	// INC_MI32_LIDARENUMS_H
