/**
 * \file rvc/styletype.h 
 * \brief interface for the RVC::STYLE class.
 *
 * \if NODOC
 * $Id: styletype.h_v 1.5 2013/11/15 16:02:41 mju Exp $
 *
 * $Log: styletype.h_v $
 * Revision 1.5  2013/11/15 16:02:41  mju
 * Add stddefns hdr.
 *
 * Revision 1.2  2006/09/18 17:53:43  scowan
 * Adjusted for new enums and pattern class names.
 *
 * Revision 1.1  2006/09/15 19:56:36  scowan
 * Initial revision
 * \endif
**/

#ifndef INC_RVC_STYLETYPE_H
#define INC_RVC_STYLETYPE_H

#ifndef	INC_MI32_STDDEFNS_H
#include <mi32/stddefns.h>
#endif

namespace RVC {

//! Style type.
enum STYLETYPE {
	STYLETYPE_First = 0,
	STYLETYPE_Point = 0,
	STYLETYPE_Line = 1,
	STYLETYPE_Polygon = 2,
	STYLETYPE_Text = 3,
	STYLETYPE_NumTypes =	4
	};

#ifndef GENERATING_DOXYGEN_OUTPUT
DEFINE_ENUM_OP_INCREMENT(STYLETYPE)
#endif

//! Pattern type.
enum PATTERNTYPE {
	PATTERNTYPE_Symbol = 0,
	PATTERNTYPE_Line,
	PATTERNTYPE_Bitmap,
	PATTERNTYPE_Hatch,
	PATTERNTYPE_NumTypes
	};

#ifndef GENERATING_DOXYGEN_OUTPUT
DEFINE_ENUM_OP_INCREMENT(PATTERNTYPE)
#endif

}		//! End of RVC namespace

#endif 	// INC_RVC_STYLETYPE_H
