/**
 * \file sml/common.h
 * \brief SML::COMMON definitions
 *
 * \if NODOC
 * $Id: common.h_v 1.1 2015/02/27 20:14:37 mju Exp $
 *
 * $Log: common.h_v $
 * Revision 1.1  2015/02/27 20:14:37  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_SML_COMMON_H
#define	INC_SML_COMMON_H

#ifndef	INC_SML_FLAG_H
#include <sml/flag.h>
#endif

namespace SML {

//=====================================================================================================================

//! Common / shared parameter and flag definitions.
class COMMON {
	public:

		//! Get array of FLAG values for ELEMTYPE, suitable for SML::STRING::FlagTextToValueSingle.
		static const FLAG* FLAGS_ElemType ();

		//! Get array of FLAG values for RVC::OBJECT::OPENMODE, suitable for SML::STRING::FlagTextToValueSingle.
		static const FLAG* FLAGS_RVC_OpenMode ();
	};

//=====================================================================================================================

}	// End namespace SML

#endif	// INC_SML_COMMON_H
