/**
 * \file spatmod/imagehelperdebug.h
 * \brief SPATMOD::IMAGE::HELPER_DEBUG definitions
 *
 * \if NODOC
 * $Id: imagehelperdebug.h_v 1.1 2015/09/23 13:26:53 mju Exp $
 *
 * $Log: imagehelperdebug.h_v $
 * Revision 1.1  2015/09/23 13:26:53  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_SPATMOD_IMAGEHELPERDEBUG_H
#define	INC_SPATMOD_IMAGEHELPERDEBUG_H

#ifndef	INC_SPATMOD_IMAGESTAGE_H
#include <spatmod/imagestage.h>
#endif

#ifndef	GENERATING_DOXYGEN_OUTPUT
class FILEPATH;
class MISTRING;
#endif

namespace SPATMOD {
namespace IMAGE {

//=====================================================================================================================

class HELPER_DEBUG {
	public:

		static ERRVALUE SaveImage (
			STAGE &StageInput,
			const MISTRING &FileName,			//!< File name with no path or extension
			const MISTRING &ObjName,			//!< Object name
			bool bAddTimeStamp = false			//!< Add timestamp to object name
			);

		static void SetBaseFolder (
			const FILEPATH &folderpath			//!< Existing folder path
			);

	};

//=====================================================================================================================

}	// End namespace IMAGE
}	// End namespace SPATMOD

#endif	// INC_SPATMOD_IMAGEHELPERDEBUG_H
