/**
 * \file spatmod/imagemosaicenums.h
 * \brief Spatial Modelling (SPATMOD) IMAGE::MOSAIC_... enum values.
 *
 * \if NODOC
 * $Id: imagemosaicenums.h_v 1.1 2016/01/18 21:12:25 mju Exp $
 *
 * $Log: imagemosaicenums.h_v $
 * Revision 1.1  2016/01/18 21:12:25  mju
 * Initial revision
 *
 * \endif
**/

#ifndef	INC_SPATMOD_IMAGEMOSAICENUMS_H
#define	INC_SPATMOD_IMAGEMOSAICENUMS_H

namespace SPATMOD {
namespace IMAGE {

//=====================================================================================================================

//! Mosaic overlap modes.
enum MOSAIC_OVERLAP {
	MOSAIC_OVERLAP_First,						//!< Use first valid pixel
	MOSAIC_OVERLAP_Last,							//!< Use last valid pixel
	MOSAIC_OVERLAP_Minimum,						//!< Use pixel with minimum total of sample values
	MOSAIC_OVERLAP_Maximum,						//!< Use pixel with maximum total of sample values
	MOSAIC_OVERLAP_ClosestToSpecified,		//!< Use pixel closest to specified value
	MOSAIC_OVERLAP_ClosestToSourceCenter	//!< Use pixel closest to source image center
	};

//=====================================================================================================================

enum MOSAIC_FEATHER {
	MOSAIC_FEATHER_None,
	MOSAIC_FEATHER_Linear,
	MOSAIC_FEATHER_Nonlinear
	};

//=====================================================================================================================

}	// End namespace IMAGE
}	// End namespace SPATMOD

#endif	// INC_SPATMOD_IMAGEMOSAICENUMS_H
