/**
 * \file spatmod/imagetargettilesetrvc.h
 * \brief Spatial Modelling (SPATMOD) IMAGE::TARGET_TILESET_RVC definition.
 *
 * \if NODOC
 * $Id$
 *
 * $Log$
 * \endif
**/

#ifndef	INC_SPATMOD_IMAGETARGETTILESETRVC_H
#define	INC_SPATMOD_IMAGETARGETTILESETRVC_H

#ifndef	INC_SPATMOD_IMAGETARGETILESETFILE_H
#include <spatmod/imagetargettilesetfile.h>
#endif

#ifndef GENERATING_DOXYGEN_OUTPUT
class MISTATUSCONTEXT;
namespace RVC {
	class OBJITEM;
	}
#endif

namespace SPATMOD {
namespace IMAGE {

//=====================================================================================================================

//! RVC target.
class TARGET_TILESET_RVC : public TARGET_TILESET_FILE {
	public:

		//! Constructor.
		TARGET_TILESET_RVC (
			STAGE *pInputStage,						//!< Stage in pipeline to obtain image data from
			const RVC::OBJITEM& ObjItemTgt,
			const IMAGE::TILESET& tileset
			);

		//! Destructor.
		virtual ~TARGET_TILESET_RVC ();

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		typedef TARGET_TILESET_FILE BASECLASS;

		RVC::OBJITEM *m_pObjItemTgt;
		MISTATUSCONTEXT *m_pStatusContext;

		MISTRING GetCombinedName () const;

		// TARGET overrides.
		virtual ERRVALUE v_Initialize ();
		virtual ERRVALUE v_PushBegin (const SECTION_ITERATOR& iterator);
		virtual ERRVALUE v_PushEnd ();

		// Unimplemented
		TARGET_TILESET_RVC (const TARGET_TILESET_RVC&);
		TARGET_TILESET_RVC& operator= (const TARGET_TILESET_RVC&);
		#endif // GENERATING_DOXYGEN_OUTPUT

	};

//=====================================================================================================================

}	// End namespace IMAGE
}	// End namespace SPATMOD

#endif	// INC_SPATMOD_IMAGETARGETTILESETRVC_H

